// Objective-C API for talking to github.com/renatoathaydes/go-hash/mobileapi Go package.
//   gobind -lang=objc github.com/renatoathaydes/go-hash/mobileapi
//
// File is generated by gobind. Do not edit.

#ifndef __Mobileapi_H__
#define __Mobileapi_H__

@import Foundation;
#include "Universe.objc.h"


@class MobileapiDatabase;
@class MobileapiEntry;
@class MobileapiEntryIterator;
@class MobileapiGroupIterator;

/**
 * Database a go-hash database.
 */
@interface MobileapiDatabase : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)fileName;
- (void)setFileName:(NSString*)v;
/**
 * Iter returns a GroupIterator which can be used to iterate over the groups in this database.
 */
- (MobileapiGroupIterator*)iter;
@end

/**
 * Entry is a wrapper around a LoginInfo instance.
LoginInfo cannot be exposed directly due to the gomobile tool's limitations.
 */
@interface MobileapiEntry : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
/**
 * Description of this Entry.
 */
- (NSString*)description;
/**
 * Name of this Entry.
 */
- (NSString*)name;
/**
 * Password of this Entry.
 */
- (NSString*)password;
/**
 * UpdatedAt the instance at which this entry was last updated.
As epoch-milliseconds since 1970-01-01T00:00:00.
 */
- (int64_t)updatedAt;
/**
 * Url of this Entry.
 */
- (NSString*)url;
/**
 * Username of this Entry.
 */
- (NSString*)username;
@end

/**
 * EntryIterator allows iterating over all LoginInfo entries in a group.
 */
@interface MobileapiEntryIterator : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)group;
- (void)setGroup:(NSString*)v;
/**
 * Next returns the next Entry, if any, or nil if none is available.
 */
- (MobileapiEntry*)next;
@end

/**
 * GroupIterator allows iterating over all groups in the database.
 */
@interface MobileapiGroupIterator : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
/**
 * Next returns the next EntryIterator, if any, or nil if none is available.
 */
- (MobileapiEntryIterator*)next;
@end

/**
 * ReadDatabase reads a go-hash database.
 */
FOUNDATION_EXPORT MobileapiDatabase* MobileapiReadDatabase(NSString* filePath, NSString* password, NSError** error);

#endif
